import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;

public class Distribution {
	int[] values;
	ArrayList<Integer> valuesSorted = new ArrayList<Integer>();
	int[] absoluteFrequencies;
	double[] relativeFrequencies;

	public Distribution(int[] values) {
		this.values = values;
		for(int i = 0; i < values.length; i++)
			valuesSorted.add(values[i]);
		HashSet<Integer> hashSet = new HashSet<Integer>(valuesSorted);
		valuesSorted = new ArrayList<Integer>(hashSet);
		Collections.sort(valuesSorted);
		absoluteFrequencies = new int[valuesSorted.size()];
		relativeFrequencies = new double[valuesSorted.size()];
		for(int i = 0; i < valuesSorted.size(); i++){
			int searchValue = valuesSorted.get(i);
			int counter = 0;
			for(int j = 0; j < values.length; j++)
				if(values[j] == searchValue)
					counter++;
			absoluteFrequencies[i] = counter;
		}
		for(int i = 0; i < absoluteFrequencies.length; i++)
			relativeFrequencies[i] = absoluteFrequencies[i] * 1.0 / values.length;
	}
	
	int getValueWithHighestProbability(){
		double highestProbability = -1;
		int valueWithHighestProbability = -1;
		for(int i = 0; i < valuesSorted.size(); i++){
			if(relativeFrequencies[i] > highestProbability){
				highestProbability = relativeFrequencies[i];
				valueWithHighestProbability = valuesSorted.get(i);
			}
		}
		return valueWithHighestProbability;
	}
}