import java.util.Random;

public class Instance_LotSizing extends Instance{
	Random rand;
	double[] demands, demands_forecasted;
	double A = 50;
	double h = 0.1;

	public Instance_LotSizing(int seed, int T) {
		super(T);
		demands = new double[T];
		rand = new Random(seed);
		for(int t = 0; t < T; t++)
			demands[t] = rand.nextInt(100);
		demands_forecasted = new double[T];
	}
	
	void createForecasts(double gradualLossFactor, int t_current, int lookahead){
		for(int t = 0; t < T; t++)
			if(t < t_current + lookahead)
				demands_forecasted[t] = demands[t];
			else{
				demands_forecasted[t] = demands[t] + (t - t_current) * (-gradualLossFactor + 2*gradualLossFactor * rand.nextDouble());
				if(demands_forecasted[t] < 0)
					demands_forecasted[t] = 0;
				else if(demands_forecasted[t] > 100)
					demands_forecasted[t] = 100;
			}
				
	}
}