import java.util.Random;

public class Instance_TSP extends Instance{
	Random rand;
	double[] x, y, x_forecasted, y_forecasted;

	public Instance_TSP(int seed, int T) {
		super(T);
		x = new double[T];
		y = new double[T];
		rand = new Random(seed);
		for(int t = 0; t < T; t++){
			x[t] = rand.nextDouble();
			y[t] = rand.nextDouble();
		}
		x_forecasted = new double[T];
		y_forecasted = new double[T];
	}
	
	void createForecasts(double gradualLossFactor, int t_current, int lookahead){
		for(int t = 0; t < T; t++)
			if(t < t_current + lookahead){
				x_forecasted[t] = x[t];
				y_forecasted[t] = y[t];
			}
			else{
				x_forecasted[t] = x[t] + (t - t_current) * (-gradualLossFactor + 2*gradualLossFactor * rand.nextDouble());
				if(x_forecasted[t] < 0)
					x_forecasted[t] = 0;
				else if(x_forecasted[t] > 1)
					x_forecasted[t] = 1;
				y_forecasted[t] = y[t] + (t - t_current) * (-gradualLossFactor + 2*gradualLossFactor * rand.nextDouble());
				if(y_forecasted[t] < 0)
					y_forecasted[t] = 0;
				else if(y_forecasted[t] > 1)
					y_forecasted[t] = 1;
			}
	}
}